SoTextureScalePolicy Class Reference
Node Classes

The SoTextureScalePolicy class is a node for controlling the texture scale policy. More...

`#include <Inventor/nodes/SoTextureScalePolicy.h>`

Inheritance diagram for SoTextureScalePolicy:

## Public Types

enum | Policy { USE_TEXTURE_QUALITY , SCALE_DOWN , SCALE_UP , FRACTURE }
Public Types inherited from SoNode

enum

NodeType {
INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 ,
INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 ,
COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 ,
COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 ,
COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000
}

## Public Member Functions

virtual SoType | getTypeId (void) const
| SoTextureScalePolicy (void)
virtual void | GLRender (SoGLRenderAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | doAction (SoAction *action)
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFEnum | policy
SoSFFloat | quality

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTextureScalePolicy ()
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTextureScalePolicy class is a node for controlling the texture scale policy.

If a texture map is of size != 2^n, it must be scaled before OpenGL can handle it. This node enables you to control how/if textures are scaled before they are sent to OpenGL.

Also, if a texture map is bigger than the maximum OpenGL texture size (implementation and context dependent), it will be scaled down to the maximum size. You can avoid this by setting the texture policy to SoTextureScalePolicy::FRACTURE, in which case the texture will be split into several small subtextures before the geometry using the texture is rendered.

Setting SoTextureScalePolicy::policy to SoTextureScalePolicy::FRACTURE will also cause the internal texture handling unit in Coin to automatically downsample the individual subtextures to not use more graphics card memory than necessary to cover the current screen size of the texture.

These two aspects of SoTextureScalePolicy::FRACTURE rendering together, subtexture fracturing and automatic downsampling, makes it possible to have textures with almost unlimited size. The only real limit is the amount of memory on the system, since the entire texture must fit into CPU memory.

The SoTextureScalePolicy::FRACTURE policy is also very handy for using the Coin libraries built-in handling of non-power-of-2 textures. This will then be done completely transparent to the application programmer, for maximum convenience. Below is a very simple example which demonstrates how to use it. The texture has dimensions 3x3, but no scaling (and thereby interpolation) will have to be done when SoTextureScalePolicy::FRACTURE is specified:

    #Inventor V2.1 ascii

    Separator {
       TextureScalePolicy { policy FRACTURE }
       Complexity { textureQuality 0.01 }  # don't generate smoothed mipmaps
       Texture2 {
          image 3 3 4  # dimensions 3x3, RGBA (4-component) image
          0xff0000ff 0x00ff00ff 0x0000ffff  # red, green, blue
          0xffff00ff 0xff00ffff 0x00ffffff  # yellow, magenta, cyan
          0x222222ff 0x777777ff 0xccccccff  # dark, medium and light gray
       }
       Cube { }
    }

Be aware that the triangle throughput is much slower when using the FRACTURE texture mode, since all triangles need to be clipped (using the CPU) against subtextures. It's therefore usually not a good idea to use the FRACTURE mode on large triangle meshes.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.
FILE FORMAT/DEFAULTS:

TextureScalePolicy {
policy USE_TEXTURE_QUALITY
quality 0.5
}
SoTextureScalePolicy::quality
SoSFFloat quality
Definition SoTextureScalePolicy.h:57
SoTextureScalePolicy::USE_TEXTURE_QUALITY
@ USE_TEXTURE_QUALITY
Definition SoTextureScalePolicy.h:50
SoTextureScalePolicy::policy
SoSFEnum policy
Definition SoTextureScalePolicy.h:56

Since
  Coin 2.0

## Member Enumeration Documentation

## Policy

enum SoTextureScalePolicy::Policy

Enumerates the available policy settings.

Enumerator
USE_TEXTURE_QUALITY | Uses the texture quality to decide whether to scale up or down.
SCALE_DOWN | Always scales down.
SCALE_UP | Always scales up.

FRACTURE

Splits the texture into several subtextures, and clips the geometry into each subtexture. Also automatically downsamples the subtextures to not use more graphics card memory than necessary versus the current screen size of the texture.

These two features makes it possible to have textures with almost unlimited size. The only real limit is the amount of memory on the system, since the entire texture must fit into CPU memory.

Be aware that the rendering is quite slow with this mode if the texture(s) will be mapped onto lots of polygon primitives.

## Constructor & Destructor Documentation

## SoTextureScalePolicy()

SoTextureScalePolicy::SoTextureScalePolicy | ( | void |  | ) |

Constructor.

## ~SoTextureScalePolicy()

SoTextureScalePolicy::~SoTextureScalePolicy | ( |  | ) |

protected virtual

Destructor.

## Member Function Documentation

## getClassTypeId()

SoType SoTextureScalePolicy::getClassTypeId | ( | void |  | ) |

static

This static method returns the SoType object associated with objects of this class.

## getTypeId()

SoType SoTextureScalePolicy::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## getFieldDataPtr()

const SoFieldData ** SoTextureScalePolicy::getFieldDataPtr | ( | void |  | ) |

static protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## getFieldData()

const SoFieldData * SoTextureScalePolicy::getFieldData | ( | void |  | ) | const

protected virtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## GLRender()

void SoTextureScalePolicy::GLRender | ( | SoGLRenderAction * | action | ) |

virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## Member Data Documentation

## policy

SoSFEnum SoTextureScalePolicy::policy

The policy setting. Default value is USE_TEXTURE_QUALITY.

USE_TEXTURE_QUALITY means that SoComplexity::textureQuality will be used to decide if the texture should be scaled up or down. SoComplexity::textureQuality >= 0.7 means scale up, while < 0.7 means scale down. Textures smaller than 256 pixels are never scaled down since you lose too much information.

## quality

SoSFFloat SoTextureScalePolicy::quality

The texture scale/resize quality. Default value is 0.5.

This field can be used to force Coin to use a lower quality (but much faster) image resize function. Currently, if you set this field to a value < 0.5, a low quality resize function will be used, otherwise a high quality (but slow) function will be used.

The documentation for this class was generated from the following files:

- SoTextureScalePolicy.h
- SoTextureScalePolicy.cpp